/*
This is a part of the XProp LiteStep module source code.

Copyright (C) 2003 ilmcuts

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include "utility.h"
#include <strsafe.h>


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// DisplayMessage
//
int DisplayMessage(LPCTSTR ptzMessage, LPCTSTR ptzTitle, UINT uExtraFlags)
{
    return MessageBox(NULL, ptzMessage, ptzTitle,
        MB_TOPMOST | MB_SETFOREGROUND | uExtraFlags);
}

int DisplayMessage(LPCTSTR ptzMessage, UINT uExtraFlags)
{
    return DisplayMessage(ptzMessage, g_tzModuleName, uExtraFlags);
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// AskUser
//
int AskUser(UINT uFlags, LPCTSTR ptzFormat, ...)
{
    TCHAR tzMessage[MAX_LINE_LENGTH];
    va_list argList;
    
    va_start(argList, ptzFormat);
    StringCchVPrintf(tzMessage, MAX_LINE_LENGTH, ptzFormat, argList);
    va_end(argList);
    
    return DisplayMessage(tzMessage, uFlags);
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// ErrorMessage
//
void ErrorMessage(LPCTSTR ptzMessage)
{
    DisplayMessage(ptzMessage, MB_ICONERROR);
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// ErrorMessagef
//
void ErrorMessagef(LPCTSTR ptzFormat, ...)
{
    TCHAR tzMessage[MAX_LINE_LENGTH];
    va_list argList;
    
    va_start(argList, ptzFormat);
    StringCchVPrintf(tzMessage, MAX_LINE_LENGTH, ptzFormat, argList);
    va_end(argList);
    
    ErrorMessage(tzMessage);
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// ReportLastError
//
void ReportLastError()
{
    void* pMsgBuf;
    
    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER |
        FORMAT_MESSAGE_FROM_SYSTEM |
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        GetLastError(),
        0,               // system language
        (LPTSTR)&pMsgBuf,
        0,
        NULL
        );
    
    ErrorMessage((LPCTSTR)pMsgBuf);
    LocalFree(pMsgBuf);
}


